'use strict';

var require$$0 = require('inline-source');
var through = require('through2');
var PluginError = require('plugin-error');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var require$$0__default = /*#__PURE__*/_interopDefaultLegacy(require$$0);
var through__default = /*#__PURE__*/_interopDefaultLegacy(through);
var PluginError__default = /*#__PURE__*/_interopDefaultLegacy(PluginError);

const { inlineSource } = require$$0__default['default'];



const PLUGIN_NAME = 'gulp-inline-source-html';

/**
 * inline-source wrapper
 * @param {Object} [options] - https://github.com/popeindustries/inline-source#usage
 */
const gulpInlineSourceHtml = (pluginOptions = {}) => {
  return through__default['default'].obj((file, _, callback) => {
    if (file.isNull()) {
      return callback(null, file)
    }

    if (file.isStream()) {
      return callback(new PluginError__default['default'](PLUGIN_NAME, 'Streaming not supported'))
    }

    const defaultOptions = { rootpath: file.base };
    const options = { ...defaultOptions, ...pluginOptions }
    ;(async () => {
      try {
        const newFileContents = await inlineSource(
          String(file.contents),
          options
        );
        file.contents = Buffer.from(newFileContents);
        callback(null, file);
      } catch (err) {
        callback(new PluginError__default['default'](PLUGIN_NAME, err));
      }
    })();
  })
};

var src = gulpInlineSourceHtml;

module.exports = src;
